From 234b3c8107c3c3ac0823550298c6d840e22813d7 Mon Sep 17 00:00:00 2001
From: Vijay Kiran Kamuju <infyquest@gmail.com>
Date: Sat, 1 Feb 2020 05:09:14 +0100
Subject: [PATCH] [include] update fields of SYSTEM_TIMEOFDAY_INFORMATION

Signed-off-by: Vijay Kiran Kamuju <infyquest@gmail.com>
---
 include/winternl.h | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/include/winternl.h b/include/winternl.h
index b485fdd41f..58268f206f 100644
--- a/include/winternl.h
+++ b/include/winternl.h
@@ -1442,7 +1442,9 @@ typedef struct _SYSTEM_TIMEOFDAY_INFORMATION {
     LARGE_INTEGER liKeSystemTime;
     LARGE_INTEGER liExpTimeZoneBias;
     ULONG uCurrentTimeZoneId;
-    DWORD dwUnknown1[5];
+    ULONG Reserved;
+    ULONGLONG BootTimeBias;
+    ULONGLONG SleepTimeBias;
 #else
     BYTE Reserved1[48];
 #endif
-- 
2.25.0