Index: childwnd.c
===================================================================
RCS file: /home/wine/wine/programs/regedit/childwnd.c,v
retrieving revision 1.1
diff -u -r1.1 childwnd.c
--- childwnd.c	7 Aug 2003 03:10:13 -0000	1.1
+++ childwnd.c	1 Dec 2003 23:24:58 -0000
@@ -18,6 +18,9 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
+#include "config.h"
+#include "wine/port.h"
+
 #define WIN32_LEAN_AND_MEAN     /* Exclude rarely-used stuff from Windows headers */
 #include <windows.h>
 #include <tchar.h>
@@ -26,7 +29,9 @@
 #define ASSERT assert
 
 #include "main.h"
+#include "wine/debug.h"
 
+WINE_DEFAULT_DEBUG_CHANNEL(regedit);
 
 /*******************************************************************************
  * Local module support methods
@@ -85,7 +90,7 @@
 
     GetClientRect(hWnd, &rt);
     hdc = BeginPaint(hWnd, &ps);
-    FillRect(ps.hdc, &rt, GetStockObject(LTGRAY_BRUSH));
+    FillRect(ps.hdc, &rt, GetSysColorBrush(COLOR_BTNFACE));
     EndPaint(hWnd, &ps);
 }
 
@@ -113,6 +118,193 @@
 	return TRUE;
 }
 
+struct {
+   char *Name;
+   ULONG Id;
+} Messages[] =
+{
+   {"WM_ACTIVATE", WM_ACTIVATE},
+   {"WM_ACTIVATEAPP", WM_ACTIVATEAPP},
+   {"WM_ASKCBFORMATNAME", WM_ASKCBFORMATNAME},
+   {"WM_CANCELJOURNAL", WM_CANCELJOURNAL},
+   {"WM_CANCELMODE", WM_CANCELMODE},
+   {"WM_CAPTURECHANGED", 533},
+   {"WM_CHANGECBCHAIN", 781},
+   {"WM_CHAR", 258},
+   {"WM_CHARTOITEM", 47},
+   {"WM_CHILDACTIVATE", 34},
+   {"WM_CLEAR", 771},
+   {"WM_CLOSE", 16},
+   {"WM_COMMAND", 273},
+   {"WM_COMMNOTIFY", 68},
+   {"WM_COMPACTING", 65},
+   {"WM_COMPAREITEM", 57},
+   {"WM_CONTEXTMENU", 123},
+   {"WM_COPY", 769},
+   {"WM_COPYDATA", 74},
+   {"WM_CREATE", 1},
+   {"WM_CTLCOLORBTN", 309},
+   {"WM_CTLCOLORDLG", 310},
+   {"WM_CTLCOLOREDIT", 307},
+   {"WM_CTLCOLORLISTBOX", 308},
+   {"WM_CTLCOLORMSGBOX", 306},
+   {"WM_CTLCOLORSCROLLBAR", 311},
+   {"WM_CTLCOLORSTATIC", 312},
+   {"WM_CUT", 768},
+   {"WM_DEADCHAR", 259},
+   {"WM_DELETEITEM", 45},
+   {"WM_DESTROY", 2},
+   {"WM_DESTROYCLIPBOARD", 775},
+   {"WM_DEVICECHANGE", 537},
+   {"WM_DEVMODECHANGE", 27},
+   {"WM_DISPLAYCHANGE", 126},
+   {"WM_DRAWCLIPBOARD", 776},
+   {"WM_DRAWITEM", 43},
+   {"WM_DROPFILES", 563},
+   {"WM_ENABLE", 10},
+   {"WM_ENDSESSION", 22},
+   {"WM_ENTERIDLE", 289},
+   {"WM_ENTERMENULOOP", 529},
+   {"WM_ENTERSIZEMOVE", 561},
+   {"WM_ERASEBKGND", 20},
+   {"WM_EXITMENULOOP", 530},
+   {"WM_EXITSIZEMOVE", 562},
+   {"WM_FONTCHANGE", 29},
+   {"WM_GETDLGCODE", 135},
+   {"WM_GETFONT", 49},
+   {"WM_GETHOTKEY", 51},
+   {"WM_GETICON", 127},
+   {"WM_GETMINMAXINFO", 36},
+   {"WM_GETTEXT", 13},
+   {"WM_GETTEXTLENGTH", 14},
+   {"WM_HANDHELDFIRST", 856},
+   {"WM_HANDHELDLAST", 863},
+   {"WM_HELP", 83},
+   {"WM_HOTKEY", 786},
+   {"WM_HSCROLL", 276},
+   {"WM_HSCROLLCLIPBOARD", 782},
+   {"WM_ICONERASEBKGND", 39},
+   {"WM_INITDIALOG", 272},
+   {"WM_INITMENU", 278},
+   {"WM_INITMENUPOPUP", 279},
+   {"WM_INPUTLANGCHANGE", 81},
+   {"WM_INPUTLANGCHANGEREQUEST", 80},
+   {"WM_KEYDOWN", 256},
+   {"WM_KEYUP", 257},
+   {"WM_KILLFOCUS", 8},
+   {"WM_MDIACTIVATE", 546},
+   {"WM_MDICASCADE", 551},
+   {"WM_MDICREATE", 544},
+   {"WM_MDIDESTROY", 545},
+   {"WM_MDIGETACTIVE", 553},
+   {"WM_MDIICONARRANGE", 552},
+   {"WM_MDIMAXIMIZE", 549},
+   {"WM_MDINEXT", 548},
+   {"WM_MDIREFRESHMENU", 564},
+   {"WM_MDIRESTORE", 547},
+   {"WM_MDISETMENU", 560},
+   {"WM_MDITILE", 550},
+   {"WM_MEASUREITEM", 44},
+   {"WM_MENURBUTTONUP", 290},
+   {"WM_MENUCHAR", 288},
+   {"WM_MENUSELECT", 287},
+   {"WM_NEXTMENU", 531},
+   {"WM_MOVE", 3},
+   {"WM_MOVING", 534},
+   {"WM_NCACTIVATE", 134},
+   {"WM_NCCALCSIZE", 131},
+   {"WM_NCCREATE", 129},
+   {"WM_NCDESTROY", 130},
+   {"WM_NCHITTEST", 132},
+   {"WM_NCLBUTTONDBLCLK", 163},
+   {"WM_NCLBUTTONDOWN", 161},
+   {"WM_NCLBUTTONUP", 162},
+   {"WM_NCMBUTTONDBLCLK", 169},
+   {"WM_NCMBUTTONDOWN", 167},
+   {"WM_NCMBUTTONUP", 168},
+   {"WM_NCMOUSEMOVE", 160},
+   {"WM_NCPAINT", 133},
+   {"WM_NCRBUTTONDBLCLK", 166},
+   {"WM_NCRBUTTONDOWN", 164},
+   {"WM_NCRBUTTONUP", 165},
+   {"WM_NEXTDLGCTL", 40},
+   {"WM_NEXTMENU", 531},
+   {"WM_NOTIFY", 78},
+   {"WM_NOTIFYFORMAT", 85},
+   {"WM_NULL", 0},
+   {"WM_PAINT", 15},
+   {"WM_PAINTCLIPBOARD", 777},
+   {"WM_PAINTICON", 38},
+   {"WM_PALETTECHANGED", 785},
+   {"WM_PALETTEISCHANGING", 784},
+   {"WM_PARENTNOTIFY", 528},
+   {"WM_PASTE", 770},
+   {"WM_PENWINFIRST", 896},
+   {"WM_PENWINLAST", 911},
+   {"WM_POWER", 72},
+   {"WM_POWERBROADCAST", 536},
+   {"WM_PRINT", 791},
+   {"WM_PRINTCLIENT", 792},
+   {"WM_QUERYDRAGICON", 55},
+   {"WM_QUERYENDSESSION", 17},
+   {"WM_QUERYNEWPALETTE", 783},
+   {"WM_QUERYOPEN", 19},
+   {"WM_QUEUESYNC", 35},
+   {"WM_QUIT", 18},
+   {"WM_RENDERALLFORMATS", 774},
+   {"WM_RENDERFORMAT", 773},
+   {"WM_SETCURSOR", 32},
+   {"WM_SETFOCUS", 7},
+   {"WM_SETFONT", 48},
+   {"WM_SETHOTKEY", 50},
+   {"WM_SETICON", 128},
+   {"WM_SETREDRAW", 11},
+   {"WM_SETTEXT", 12},
+   {"WM_SETTINGCHANGE", 26},
+   {"WM_SHOWWINDOW", 24},
+   {"WM_SIZE", 5},
+   {"WM_SIZECLIPBOARD", 779},
+   {"WM_SIZING", 532},
+   {"WM_SPOOLERSTATUS", 42},
+   {"WM_STYLECHANGED", 125},
+   {"WM_STYLECHANGING", 124},
+   {"WM_SYSCHAR", 262},
+   {"WM_SYSCOLORCHANGE", 21},
+   {"WM_SYSCOMMAND", 274},
+   {"WM_SYSDEADCHAR", 263},
+   {"WM_SYSKEYDOWN", 260},
+   {"WM_SYSKEYUP", 261},
+   {"WM_TCARD", 82},
+   {"WM_TIMECHANGE", 30},
+   {"WM_TIMER", 275},
+   {"WM_UNDO", 772},
+   {"WM_USER", 1024},
+   {"WM_USERCHANGED", 84},
+   {"WM_VKEYTOITEM", 46},
+   {"WM_VSCROLL", 277},
+   {"WM_VSCROLLCLIPBOARD", 778},
+   {"WM_WINDOWPOSCHANGED", 71},
+   {"WM_WINDOWPOSCHANGING", 70},
+   {"WM_WININICHANGE", 26},
+   {"WM_KEYFIRST", 256},
+   {"WM_KEYLAST", 264},
+   {"WM_SYNCPAINT", 136},
+   {"WM_MOUSEACTIVATE", 33},
+   {"WM_MOUSEMOVE", 512},
+   {"WM_LBUTTONDOWN", 513},
+   {"WM_LBUTTONUP", 514},
+   {"WM_LBUTTONDBLCLK", 515},
+   {"WM_RBUTTONDOWN", 516},
+   {"WM_RBUTTONUP", 517},
+   {"WM_RBUTTONDBLCLK", 518},
+   {"WM_MBUTTONDOWN", 519},
+   {"WM_MBUTTONUP", 520},
+   {"WM_MBUTTONDBLCLK", 521},
+   {"WM_MOUSEWHEEL", 522},
+   {"WM_MOUSEHOVER", 0x2A1},
+   {"WM_MOUSELEAVE", 0x2A3}
+};  
+   
 /*******************************************************************************
  *
  *  FUNCTION: ChildWndProc(HWND, unsigned, WORD, LONG)
@@ -129,6 +321,25 @@
     static int last_split;
 /*    ChildWnd* pChildWnd = (ChildWnd*)GetWindowLong(hWnd, GWL_USERDATA); */
     static ChildWnd* pChildWnd;
+
+        {
+           int i;
+           char *name = NULL;
+
+           for (i = sizeof(Messages) / sizeof(Messages[0]); i--; )
+              if (message == Messages[i].Id)
+              {
+                 name = Messages[i].Name;
+                 break;
+              }
+
+           if (name)
+              WINE_TRACE("Window: %x Message: %s (%x) wParam: %x lParam: %x\n",
+                 hWnd, name, message, wParam, lParam);
+           else
+              WINE_TRACE("Window: %x Message: %x wParam: %x lParam: %x\n",
+                 hWnd, message, wParam, lParam);
+        }
 
     switch (message) {
     case WM_CREATE:

Python is not available !
cvs diff -u framewnd.c 
Index: framewnd.c
===================================================================
RCS file: /home/wine/wine/programs/regedit/framewnd.c,v
retrieving revision 1.1
diff -u -r1.1 framewnd.c
--- framewnd.c	7 Aug 2003 03:10:13 -0000	1.1
+++ framewnd.c	1 Dec 2003 23:25:28 -0000
@@ -513,7 +513,7 @@
         _tcsncpy(pChildWnd->szPath, _T("My Computer"), MAX_PATH);
         hChildWnd = CreateWindowEx(0, szChildClass, _T("regedit child window"),
 /*                    WS_CHILD|WS_CLIPCHILDREN|WS_VISIBLE|WS_BORDER,*/
-                    WS_CHILD|WS_VISIBLE | WS_EX_CLIENTEDGE,
+                    WS_CHILD|WS_VISIBLE,
                     CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                     hWnd, (HMENU)0, hInst, pChildWnd);
         }